diff --git a/gcc/config/s390/s390.c b/gcc/config/s390/s390.c
index 7a79286..651e04e 100644
--- a/gcc/config/s390/s390.c
+++ b/gcc/config/s390/s390.c
@@ -1891,7 +1891,7 @@ s390_decompose_address (rtx addr, struct s390_address *out)
 	      && frame_pointer_needed
 	      && REGNO (base) == HARD_FRAME_POINTER_REGNUM)
 	  || REGNO (base) == ARG_POINTER_REGNUM
-          || (flag_pic
+          || (GCC_OPTION (flag_pic)
               && REGNO (base) == PIC_OFFSET_TABLE_REGNUM))
         pointer = base_ptr = true;
 
@@ -1939,7 +1939,7 @@ s390_decompose_address (rtx addr, struct s390_address *out)
 	      && frame_pointer_needed
 	      && REGNO (indx) == HARD_FRAME_POINTER_REGNUM)
 	  || REGNO (indx) == ARG_POINTER_REGNUM
-          || (flag_pic
+          || (GCC_OPTION (flag_pic)
               && REGNO (indx) == PIC_OFFSET_TABLE_REGNUM))
         pointer = indx_ptr = true;
 
@@ -1993,7 +1993,7 @@ s390_decompose_address (rtx addr, struct s390_address *out)
       if (GET_CODE (disp) == UNSPEC
           && (XINT (disp, 1) == UNSPEC_GOT
 	      || XINT (disp, 1) == UNSPEC_GOTNTPOFF)
-	  && flag_pic == 1)
+	  && GCC_OPTION (flag_pic) == 1)
         {
 	  ;
         }
@@ -2757,7 +2757,7 @@ s390_legitimate_constant_p (enum machine_mode mode, rtx op)
   /* In the PIC case, symbolic constants must *not* be
      forced into the literal pool.  We accept them here,
      so that they will be handled by emit_symbolic_move.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return 1;
 
   /* All remaining non-PIC symbolic constants are
@@ -2781,7 +2781,7 @@ s390_cannot_force_const_mem (enum machine_mode mode, rtx x)
 
     case LABEL_REF:
       /* Labels are OK iff we are non-PIC.  */
-      return flag_pic != 0;
+      return GCC_OPTION (flag_pic) != 0;
 
     case SYMBOL_REF:
       /* 'Naked' TLS symbol references are never OK,
@@ -2789,7 +2789,7 @@ s390_cannot_force_const_mem (enum machine_mode mode, rtx x)
       if (tls_symbolic_operand (x))
 	return true;
       else
-	return flag_pic != 0;
+	return GCC_OPTION (flag_pic) != 0;
 
     case CONST:
       return s390_cannot_force_const_mem (mode, XEXP (x, 0));
@@ -2951,7 +2951,7 @@ s390_preferred_reload_class (rtx op, reg_class_t rclass)
 	    && GET_CODE (XEXP (XEXP(op, 0), 0)) == SYMBOL_REF
 	    && GET_CODE (XEXP (XEXP(op, 0), 1)) == CONST_INT)
 	  {
-	    if (flag_pic && reg_class_subset_p (ADDR_REGS, rclass))
+	    if (GCC_OPTION (flag_pic) && reg_class_subset_p (ADDR_REGS, rclass))
 	      return ADDR_REGS;
 	    else
 	      return NO_REGS;
@@ -3192,7 +3192,7 @@ s390_secondary_reload (bool in_p, rtx x, reg_class_t rclass_i,
   /* A scratch address register is needed when a symbolic constant is
      copied to r0 compiling with -fPIC.  In other cases the target
      register might be used as temporary (see legitimize_pic_address).  */
-  if (in_p && SYMBOLIC_CONST (x) && flag_pic == 2 && rclass != ADDR_REGS)
+  if (in_p && SYMBOLIC_CONST (x) && GCC_OPTION (flag_pic) == 2 && rclass != ADDR_REGS)
     sri->icode = (TARGET_64BIT ?
 		  CODE_FOR_reloaddi_PIC_addr :
 		  CODE_FOR_reloadsi_PIC_addr);
@@ -3337,7 +3337,7 @@ preferred_la_operand_p (rtx op1, rtx op2)
      preferable to use regular add instructions when possible.
      Starting with zEC12 the la with index register is "uncracked"
      again.  */
-  if (addr.indx && s390_tune == PROCESSOR_2817_Z196)
+  if (addr.indx && GCC_OPTION (s390_tune) == PROCESSOR_2817_Z196)
     return false;
 
   if (!TARGET_64BIT && !addr.pointer)
@@ -3501,7 +3501,7 @@ legitimize_pic_address (rtx orig, rtx reg)
 	  emit_move_insn (reg, new_rtx);
 	  new_rtx = reg;
 	}
-      else if (flag_pic == 1)
+      else if (GCC_OPTION (flag_pic) == 1)
         {
           /* Assume GOT offset is a valid displacement operand (< 4k
              or < 512k with z990).  This is handled the same way in
@@ -3584,7 +3584,7 @@ legitimize_pic_address (rtx orig, rtx reg)
 	  /* For -fPIC the GOT size might exceed the displacement
 	     range so make sure the value is in the literal pool.  */
 	case UNSPEC_GOT:
-	  if (flag_pic == 2)
+	  if (GCC_OPTION (flag_pic) == 2)
 	    new_rtx = force_const_mem (Pmode, orig);
 	  break;
 
@@ -3683,7 +3683,7 @@ s390_emit_tls_call_insn (rtx result_reg, rtx tls_call)
 {
   rtx insn;
 
-  if (!flag_pic)
+  if (!GCC_OPTION (flag_pic))
     emit_insn (s390_load_got ());
 
   if (!s390_tls_symbol)
@@ -3764,7 +3764,7 @@ legitimize_tls_address (rtx addr, rtx reg)
 	break;
 
       case TLS_MODEL_INITIAL_EXEC:
-	if (flag_pic == 1)
+	if (GCC_OPTION (flag_pic) == 1)
 	  {
 	    /* Assume GOT offset < 4k.  This is handled the same way
 	       in both 31- and 64-bit code.  */
@@ -3793,7 +3793,7 @@ legitimize_tls_address (rtx addr, rtx reg)
 	    temp = gen_reg_rtx (Pmode);
 	    emit_move_insn (temp, new_rtx);
 	  }
-	else if (flag_pic)
+	else if (GCC_OPTION (flag_pic))
 	  {
 	    /* If the GOT offset might be >= 4k, we have to load it
 	       from the literal pool.  */
@@ -3906,7 +3906,7 @@ emit_symbolic_move (rtx *operands)
     operands[1] = force_reg (Pmode, operands[1]);
   else if (TLS_SYMBOLIC_CONST (operands[1]))
     operands[1] = legitimize_tls_address (operands[1], temp);
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     operands[1] = legitimize_pic_address (operands[1], temp);
 }
 
@@ -3940,7 +3940,7 @@ s390_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
     {
       return x;
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
       if (SYMBOLIC_CONST (x)
           || (GET_CODE (x) == PLUS
@@ -4018,7 +4018,7 @@ rtx
 legitimize_reload_address (rtx ad, enum machine_mode mode ATTRIBUTE_UNUSED,
 			   int opnum, int type)
 {
-  if (!optimize || TARGET_LONG_DISPLACEMENT)
+  if (!GCC_OPTION (optimize) || TARGET_LONG_DISPLACEMENT)
     return NULL_RTX;
 
   if (GET_CODE (ad) == PLUS)
@@ -4062,7 +4062,7 @@ s390_expand_movmem (rtx dst, rtx src, rtx len)
   /* When tuning for z10 or higher we rely on the Glibc functions to
      do the right thing. Only for constant lengths below 64k we will
      generate inline code.  */
-  if (s390_tune >= PROCESSOR_2097_Z10
+  if (GCC_OPTION (s390_tune) >= PROCESSOR_2097_Z10
       && (GET_CODE (len) != CONST_INT || INTVAL (len) > (1<<16)))
     return false;
 
@@ -4305,7 +4305,7 @@ s390_expand_cmpmem (rtx target, rtx op0, rtx op1, rtx len)
   /* When tuning for z10 or higher we rely on the Glibc functions to
      do the right thing. Only for constant lengths below 64k we will
      generate inline code.  */
-  if (s390_tune >= PROCESSOR_2097_Z10
+  if (GCC_OPTION (s390_tune) >= PROCESSOR_2097_Z10
       && (GET_CODE (len) != CONST_INT || INTVAL (len) > (1<<16)))
     return false;
 
@@ -5871,11 +5871,11 @@ s390_adjust_priority (rtx insn ATTRIBUTE_UNUSED, int priority)
   if (! INSN_P (insn))
     return priority;
 
-  if (s390_tune != PROCESSOR_2084_Z990
-      && s390_tune != PROCESSOR_2094_Z9_109
-      && s390_tune != PROCESSOR_2097_Z10
-      && s390_tune != PROCESSOR_2817_Z196
-      && s390_tune != PROCESSOR_2827_ZEC12)
+  if (GCC_OPTION (s390_tune) != PROCESSOR_2084_Z990
+      && GCC_OPTION (s390_tune) != PROCESSOR_2094_Z9_109
+      && GCC_OPTION (s390_tune) != PROCESSOR_2097_Z10
+      && GCC_OPTION (s390_tune) != PROCESSOR_2817_Z196
+      && GCC_OPTION (s390_tune) != PROCESSOR_2827_ZEC12)
     return priority;
 
   switch (s390_safe_attr_type (insn))
@@ -5900,7 +5900,7 @@ s390_adjust_priority (rtx insn ATTRIBUTE_UNUSED, int priority)
 static int
 s390_issue_rate (void)
 {
-  switch (s390_tune)
+  switch (GCC_OPTION (s390_tune))
     {
     case PROCESSOR_2084_Z990:
     case PROCESSOR_2094_Z9_109:
@@ -6074,7 +6074,7 @@ s390_split_branches (void)
 	 make sure it will be saved/restored by the prologue/epilogue.  */
       cfun_frame_layout.save_return_addr_p = 1;
 
-      if (!flag_pic)
+      if (!GCC_OPTION (flag_pic))
 	{
 	  new_literal = 1;
 	  tmp = force_const_mem (Pmode, *label);
@@ -7673,7 +7673,7 @@ s390_register_info ()
 	  cfun_frame_layout.high_fprs++;
       }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     clobbered_regs[PIC_OFFSET_TABLE_REGNUM]
       |= !!df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM);
 
@@ -8366,7 +8366,7 @@ global_not_special_regno_p (int regno)
 	  && !(regno == STACK_POINTER_REGNUM
 	       || regno == RETURN_REGNUM
 	       || regno == BASE_REGNUM
-	       || (flag_pic && regno == (int)PIC_OFFSET_TABLE_REGNUM)));
+	       || (GCC_OPTION (flag_pic) && regno == (int)PIC_OFFSET_TABLE_REGNUM)));
 }
 
 /* Generate insn to save registers FIRST to LAST into
@@ -8784,7 +8784,7 @@ s390_emit_prologue (void)
   if (!TARGET_PACKED_STACK)
     next_fpr = cfun_save_high_fprs_p ? FPR15_REGNUM : 0;
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = cfun_frame_layout.frame_size;
 
   /* Decrement stack pointer.  */
@@ -8794,12 +8794,12 @@ s390_emit_prologue (void)
       rtx frame_off = GEN_INT (-cfun_frame_layout.frame_size);
       rtx real_frame_off;
 
-      if (s390_stack_size)
+      if (GCC_OPTION (s390_stack_size))
   	{
 	  HOST_WIDE_INT stack_guard;
 
-	  if (s390_stack_guard)
-	    stack_guard = s390_stack_guard;
+	  if (GCC_OPTION (s390_stack_guard))
+	    stack_guard = GCC_OPTION (s390_stack_guard);
 	  else
 	    {
 	      /* If no value for stack guard is provided the smallest power of 2
@@ -8809,14 +8809,14 @@ s390_emit_prologue (void)
 		stack_guard <<= 1;
 	    }
 
-	  if (cfun_frame_layout.frame_size >= s390_stack_size)
+	  if (cfun_frame_layout.frame_size >= GCC_OPTION (s390_stack_size))
 	    {
 	      warning (0, "frame size of function %qs is %wd"
 		       " bytes exceeding user provided stack limit of "
 		       "%d bytes.  "
 		       "An unconditional trap is added.",
 		       current_function_name(), cfun_frame_layout.frame_size,
-		       s390_stack_size);
+		       GCC_OPTION (s390_stack_size));
 	      emit_insn (gen_trap ());
 	    }
 	  else
@@ -8824,7 +8824,7 @@ s390_emit_prologue (void)
 	      /* stack_guard has to be smaller than s390_stack_size.
 		 Otherwise we would emit an AND with zero which would
 		 not match the test under mask pattern.  */
-	      if (stack_guard >= s390_stack_size)
+	      if (stack_guard >= GCC_OPTION (s390_stack_size))
 		{
 		  warning (0, "frame size of function %qs is %wd"
 			   " bytes which is more than half the stack size. "
@@ -8835,7 +8835,7 @@ s390_emit_prologue (void)
 		}
 	      else
 		{
-		  HOST_WIDE_INT stack_check_mask = ((s390_stack_size - 1)
+		  HOST_WIDE_INT stack_check_mask = ((GCC_OPTION (s390_stack_size) - 1)
 						    & ~(stack_guard - 1));
 
 		  rtx t = gen_rtx_AND (Pmode, stack_pointer_rtx,
@@ -8852,12 +8852,12 @@ s390_emit_prologue (void)
 	    }
   	}
 
-      if (s390_warn_framesize > 0
-	  && cfun_frame_layout.frame_size >= s390_warn_framesize)
+      if (GCC_OPTION (s390_warn_framesize) > 0
+	  && cfun_frame_layout.frame_size >= GCC_OPTION (s390_warn_framesize))
 	warning (0, "frame size of %qs is %wd bytes",
 		 current_function_name (), cfun_frame_layout.frame_size);
 
-      if (s390_warn_dynamicstack_p && cfun->calls_alloca)
+      if (GCC_OPTION (s390_warn_dynamicstack_p) && cfun->calls_alloca)
 	warning (0, "%qs uses dynamic stack allocation", current_function_name ());
 
       /* Save incoming stack pointer into temp reg.  */
@@ -8955,7 +8955,7 @@ s390_emit_prologue (void)
 
   /* Set up got pointer, if needed.  */
 
-  if (flag_pic && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM))
+  if (GCC_OPTION (flag_pic) && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM))
     {
       rtx insns = s390_load_got ();
 
@@ -9688,7 +9688,7 @@ s390_va_start (tree valist, rtx nextarg ATTRIBUTE_UNUSED)
 
       off = INTVAL (crtl->args.arg_offset_rtx);
       off = off < 0 ? 0 : off;
-      if (TARGET_DEBUG_ARG)
+      if (GCC_OPTION (TARGET_DEBUG_ARG))
 	fprintf (stderr, "va_start: n_gpr = %d, n_fpr = %d off %d\n",
 		 (int)n_gpr, (int)n_fpr, off);
 
@@ -9764,7 +9764,7 @@ s390_gimplify_va_arg (tree valist, tree type, gimple_seq *pre_p,
 
   if (pass_by_reference (NULL, TYPE_MODE (type), type, false))
     {
-      if (TARGET_DEBUG_ARG)
+      if (GCC_OPTION (TARGET_DEBUG_ARG))
 	{
 	  fprintf (stderr, "va_arg: aggregate type");
 	  debug_tree (type);
@@ -9785,7 +9785,7 @@ s390_gimplify_va_arg (tree valist, tree type, gimple_seq *pre_p,
     }
   else if (s390_function_arg_float (TYPE_MODE (type), type))
     {
-      if (TARGET_DEBUG_ARG)
+      if (GCC_OPTION (TARGET_DEBUG_ARG))
 	{
 	  fprintf (stderr, "va_arg: float type");
 	  debug_tree (type);
@@ -9801,7 +9801,7 @@ s390_gimplify_va_arg (tree valist, tree type, gimple_seq *pre_p,
     }
   else
     {
-      if (TARGET_DEBUG_ARG)
+      if (GCC_OPTION (TARGET_DEBUG_ARG))
 	{
 	  fprintf (stderr, "va_arg: other type");
 	  debug_tree (type);
@@ -10225,7 +10225,7 @@ s390_function_profiler (FILE *file, int labelno)
   SYMBOL_REF_FLAGS (op[3]) = SYMBOL_FLAG_LOCAL;
 
   op[4] = gen_rtx_SYMBOL_REF (Pmode, "_mcount");
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       op[4] = gen_rtx_UNSPEC (Pmode, gen_rtvec (1, op[4]), UNSPEC_PLT);
       op[4] = gen_rtx_CONST (Pmode, op[4]);
@@ -10238,7 +10238,7 @@ s390_function_profiler (FILE *file, int labelno)
       output_asm_insn ("brasl\t%0,%4", op);
       output_asm_insn ("lg\t%0,%1", op);
     }
-  else if (!flag_pic)
+  else if (!GCC_OPTION (flag_pic))
     {
       op[6] = gen_label_rtx ();
 
@@ -10325,7 +10325,7 @@ s390_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
 
   /* Operand 0 is the target function.  */
   op[0] = XEXP (DECL_RTL (function), 0);
-  if (flag_pic && !SYMBOL_REF_LOCAL_P (op[0]))
+  if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (op[0]))
     {
       nonlocal = 1;
       op[0] = gen_rtx_UNSPEC (Pmode, gen_rtvec (1, op[0]),
@@ -10521,17 +10521,17 @@ s390_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
       /* Jump to target.  */
       op[8] = gen_label_rtx ();
 
-      if (!flag_pic)
+      if (!GCC_OPTION (flag_pic))
 	output_asm_insn ("l\t%4,%8-%5(%4)", op);
       else if (!nonlocal)
 	output_asm_insn ("a\t%4,%8-%5(%4)", op);
       /* We cannot call through .plt, since .plt requires %r12 loaded.  */
-      else if (flag_pic == 1)
+      else if (GCC_OPTION (flag_pic) == 1)
 	{
 	  output_asm_insn ("a\t%4,%8-%5(%4)", op);
 	  output_asm_insn ("l\t%4,%0(%4)", op);
 	}
-      else if (flag_pic == 2)
+      else if (GCC_OPTION (flag_pic) == 2)
 	{
 	  op[9] = gen_rtx_REG (Pmode, 0);
 	  output_asm_insn ("l\t%9,%8-4-%5(%4)", op);
@@ -10545,7 +10545,7 @@ s390_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
       /* Output literal pool.  */
       output_asm_insn (".align\t4", op);
 
-      if (nonlocal && flag_pic == 2)
+      if (nonlocal && GCC_OPTION (flag_pic) == 2)
 	output_asm_insn (".long\t%0", op);
       if (nonlocal)
 	{
@@ -10554,7 +10554,7 @@ s390_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
 	}
 
       targetm.asm_out.internal_label (file, "L", CODE_LABEL_NUMBER (op[8]));
-      if (!flag_pic)
+      if (!GCC_OPTION (flag_pic))
 	output_asm_insn (".long\t%0", op);
       else
 	output_asm_insn (".long\t%0-%5", op);
@@ -10674,7 +10674,7 @@ s390_function_ok_for_sibcall (tree decl, tree exp)
 
   /* The 31 bit PLT code uses register 12 (GOT pointer - caller saved)
      which would have to be restored before the sibcall.  */
-  if (!TARGET_64BIT && flag_pic && decl && !targetm.binds_local_p (decl))
+  if (!TARGET_64BIT && GCC_OPTION (flag_pic) && decl && !targetm.binds_local_p (decl))
     return false;
 
   /* Register 6 on s390 is available as an argument register but unfortunately
@@ -10719,7 +10719,7 @@ s390_emit_call (rtx addr_location, rtx tls_call, rtx result_reg,
     {
       /* When calling a global routine in PIC mode, we must
          replace the symbol itself with the PLT stub.  */
-      if (flag_pic && !SYMBOL_REF_LOCAL_P (addr_location))
+      if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (addr_location))
         {
 	  if (retaddr_reg != NULL_RTX)
 	    {
@@ -10746,7 +10746,7 @@ s390_emit_call (rtx addr_location, rtx tls_call, rtx result_reg,
          routine address into a register.  */
       if (!TARGET_SMALL_EXEC && !TARGET_CPU_ZARCH)
         {
-	  if (flag_pic)
+	  if (GCC_OPTION (flag_pic))
 	    addr_location = legitimize_pic_address (addr_location, 0);
 	  else
 	    addr_location = force_reg (Pmode, addr_location);
@@ -10803,7 +10803,7 @@ s390_conditional_register_usage (void)
 {
   int i;
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fixed_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
       call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
@@ -11400,9 +11400,9 @@ s390_reorg (void)
   s390_optimize_prologue ();
 
   /* Walk over the insns and do some >=z10 specific changes.  */
-  if (s390_tune == PROCESSOR_2097_Z10
-      || s390_tune == PROCESSOR_2817_Z196
-      || s390_tune == PROCESSOR_2827_ZEC12)
+  if (GCC_OPTION (s390_tune) == PROCESSOR_2097_Z10
+      || GCC_OPTION (s390_tune) == PROCESSOR_2817_Z196
+      || GCC_OPTION (s390_tune) == PROCESSOR_2827_ZEC12)
     {
       rtx insn;
       bool insn_added_p = false;
@@ -11421,7 +11421,7 @@ s390_reorg (void)
 
 	  if ((GET_CODE (PATTERN (insn)) == PARALLEL
 	       || GET_CODE (PATTERN (insn)) == SET)
-	      && s390_tune == PROCESSOR_2097_Z10)
+	      && GCC_OPTION (s390_tune) == PROCESSOR_2097_Z10)
 	    insn_added_p |= s390_z10_optimize_cmp (insn);
 	}
 
@@ -11613,11 +11613,11 @@ static int
 s390_sched_reorder (FILE *file, int verbose,
 		    rtx *ready, int *nreadyp, int clock ATTRIBUTE_UNUSED)
 {
-  if (s390_tune == PROCESSOR_2097_Z10)
+  if (GCC_OPTION (s390_tune) == PROCESSOR_2097_Z10)
     if (reload_completed && *nreadyp > 1)
       s390_z10_prevent_earlyload_conflicts (ready, nreadyp);
 
-  if (s390_tune == PROCESSOR_2827_ZEC12
+  if (GCC_OPTION (s390_tune) == PROCESSOR_2827_ZEC12
       && reload_completed
       && *nreadyp > 1)
     {
@@ -11700,7 +11700,7 @@ s390_sched_variable_issue (FILE *file, int verbose, rtx insn, int more)
 {
   last_scheduled_insn = insn;
 
-  if (s390_tune == PROCESSOR_2827_ZEC12
+  if (GCC_OPTION (s390_tune) == PROCESSOR_2827_ZEC12
       && reload_completed
       && recog_memoized (insn) >= 0)
     {
@@ -11791,9 +11791,9 @@ s390_loop_unroll_adjust (unsigned nunroll, struct loop *loop)
   unsigned i;
   unsigned mem_count = 0;
 
-  if (s390_tune != PROCESSOR_2097_Z10
-      && s390_tune != PROCESSOR_2817_Z196
-      && s390_tune != PROCESSOR_2827_ZEC12)
+  if (GCC_OPTION (s390_tune) != PROCESSOR_2097_Z10
+      && GCC_OPTION (s390_tune) != PROCESSOR_2817_Z196
+      && GCC_OPTION (s390_tune) != PROCESSOR_2827_ZEC12)
     return nunroll;
 
   /* Count the number of memory references within the loop body.  */
@@ -11827,7 +11827,7 @@ s390_option_override (void)
   unsigned int i;
   cl_deferred_option *opt;
   vec<cl_deferred_option> *v =
-    (vec<cl_deferred_option> *) s390_deferred_options;
+    (vec<cl_deferred_option> *) GCC_OPTION (s390_deferred_options);
 
   if (v)
     FOR_EACH_VEC_ELT (*v, i, opt)
@@ -11871,42 +11871,42 @@ s390_option_override (void)
   if (!(target_flags_explicit & MASK_ZARCH))
     {
       if (TARGET_64BIT)
-	target_flags |= MASK_ZARCH;
+	GCC_OPTION (target_flags) |= MASK_ZARCH;
       else
-	target_flags &= ~MASK_ZARCH;
+	GCC_OPTION (target_flags) &= ~MASK_ZARCH;
     }
 
   /* Set the march default in case it hasn't been specified on
      cmdline.  */
-  if (s390_arch == PROCESSOR_max)
+  if (GCC_OPTION (s390_arch) == PROCESSOR_max)
     {
-      s390_arch_string = TARGET_ZARCH? "z900" : "g5";
-      s390_arch = TARGET_ZARCH ? PROCESSOR_2064_Z900 : PROCESSOR_9672_G5;
-      s390_arch_flags = processor_flags_table[(int)s390_arch];
+      GCC_OPTION (s390_arch_string) = TARGET_ZARCH? "z900" : "g5";
+      GCC_OPTION (s390_arch) = TARGET_ZARCH ? PROCESSOR_2064_Z900 : PROCESSOR_9672_G5;
+      GCC_OPTION (s390_arch_flags) = processor_flags_table[(int)GCC_OPTION (s390_arch)];
     }
 
   /* Determine processor to tune for.  */
-  if (s390_tune == PROCESSOR_max)
+  if (GCC_OPTION (s390_tune) == PROCESSOR_max)
     {
-      s390_tune = s390_arch;
-      s390_tune_flags = s390_arch_flags;
+      GCC_OPTION (s390_tune) = GCC_OPTION (s390_arch);
+      GCC_OPTION (s390_tune_flags) = GCC_OPTION (s390_arch_flags);
     }
 
   /* Sanity checks.  */
   if (TARGET_ZARCH && !TARGET_CPU_ZARCH)
-    error ("z/Architecture mode not supported on %s", s390_arch_string);
+    error ("z/Architecture mode not supported on %s", GCC_OPTION (s390_arch_string));
   if (TARGET_64BIT && !TARGET_ZARCH)
     error ("64-bit ABI not supported in ESA/390 mode");
 
   /* Use hardware DFP if available and not explicitly disabled by
      user. E.g. with -m31 -march=z10 -mzarch   */
   if (!(target_flags_explicit & MASK_HARD_DFP) && TARGET_DFP)
-    target_flags |= MASK_HARD_DFP;
+    GCC_OPTION (target_flags) |= MASK_HARD_DFP;
 
   /* Enable hardware transactions if available and not explicitly
      disabled by user.  E.g. with -m31 -march=zEC12 -mzarch */
   if (!(target_flags_explicit & MASK_OPT_HTM) && TARGET_CPU_HTM && TARGET_ZARCH)
-    target_flags |= MASK_OPT_HTM;
+    GCC_OPTION (target_flags) |= MASK_OPT_HTM;
 
   if (TARGET_HARD_DFP && !TARGET_DFP)
     {
@@ -11914,13 +11914,13 @@ s390_option_override (void)
 	{
 	  if (!TARGET_CPU_DFP)
 	    error ("hardware decimal floating point instructions"
-		   " not available on %s", s390_arch_string);
+		   " not available on %s", GCC_OPTION (s390_arch_string));
 	  if (!TARGET_ZARCH)
 	    error ("hardware decimal floating point instructions"
 		   " not available in ESA/390 mode");
 	}
       else
-	target_flags &= ~MASK_HARD_DFP;
+	GCC_OPTION (target_flags) &= ~MASK_HARD_DFP;
     }
 
   if ((target_flags_explicit & MASK_SOFT_FLOAT) && TARGET_SOFT_FLOAT)
@@ -11928,11 +11928,11 @@ s390_option_override (void)
       if ((target_flags_explicit & MASK_HARD_DFP) && TARGET_HARD_DFP)
 	error ("-mhard-dfp can%'t be used in conjunction with -msoft-float");
 
-      target_flags &= ~MASK_HARD_DFP;
+      GCC_OPTION (target_flags) &= ~MASK_HARD_DFP;
     }
 
   /* Set processor cost function.  */
-  switch (s390_tune)
+  switch (GCC_OPTION (s390_tune))
     {
     case PROCESSOR_2084_Z990:
       s390_cost = &z990_cost;
@@ -11957,24 +11957,24 @@ s390_option_override (void)
     error ("-mbackchain -mpacked-stack -mhard-float are not supported "
 	   "in combination");
 
-  if (s390_stack_size)
+  if (GCC_OPTION (s390_stack_size))
     {
-      if (s390_stack_guard >= s390_stack_size)
+      if (GCC_OPTION (s390_stack_guard) >= GCC_OPTION (s390_stack_size))
 	error ("stack size must be greater than the stack guard value");
-      else if (s390_stack_size > 1 << 16)
+      else if (GCC_OPTION (s390_stack_size) > 1 << 16)
 	error ("stack size must not be greater than 64k");
     }
-  else if (s390_stack_guard)
+  else if (GCC_OPTION (s390_stack_guard))
     error ("-mstack-guard implies use of -mstack-size");
 
 #ifdef TARGET_DEFAULT_LONG_DOUBLE_128
   if (!(target_flags_explicit & MASK_LONG_DOUBLE_128))
-    target_flags |= MASK_LONG_DOUBLE_128;
+    GCC_OPTION (target_flags) |= MASK_LONG_DOUBLE_128;
 #endif
 
-  if (s390_tune == PROCESSOR_2097_Z10
-      || s390_tune == PROCESSOR_2817_Z196
-      || s390_tune == PROCESSOR_2827_ZEC12)
+  if (GCC_OPTION (s390_tune) == PROCESSOR_2097_Z10
+      || GCC_OPTION (s390_tune) == PROCESSOR_2817_Z196
+      || GCC_OPTION (s390_tune) == PROCESSOR_2827_ZEC12)
     {
       maybe_set_param_value (PARAM_MAX_UNROLLED_INSNS, 100,
 			     global_options.x_param_values,
@@ -12016,8 +12016,8 @@ s390_option_override (void)
   /* This cannot reside in s390_option_optimization_table since HAVE_prefetch
      requires the arch flags to be evaluated already.  Since prefetching
      is beneficial on s390, we enable it if available.  */
-  if (flag_prefetch_loop_arrays < 0 && HAVE_prefetch && optimize >= 3)
-    flag_prefetch_loop_arrays = 1;
+  if (GCC_OPTION (flag_prefetch_loop_arrays) < 0 && HAVE_prefetch && GCC_OPTION (optimize) >= 3)
+    GCC_OPTION (flag_prefetch_loop_arrays) = 1;
 
   /* Use the alternative scheduling-pressure algorithm by default.  */
   maybe_set_param_value (PARAM_SCHED_PRESSURE_ALGORITHM, 2,
@@ -12029,9 +12029,9 @@ s390_option_override (void)
       /* Don't emit DWARF3/4 unless specifically selected.  The TPF
 	 debuggers do not yet support DWARF 3/4.  */
       if (!global_options_set.x_dwarf_strict) 
-	dwarf_strict = 1;
+	GCC_OPTION (dwarf_strict) = 1;
       if (!global_options_set.x_dwarf_version)
-	dwarf_version = 2;
+	GCC_OPTION (dwarf_version) = 2;
     }
 
   /* Register a target-specific optimization-and-lowering pass
diff --git a/gcc/config/s390/s390.h b/gcc/config/s390/s390.h
index 2f2139e..c8544df 100644
--- a/gcc/config/s390/s390.h
+++ b/gcc/config/s390/s390.h
@@ -47,23 +47,23 @@ enum processor_flags
    current cpu mode (ESA or z/Architecture).  */
 
 #define TARGET_CPU_IEEE_FLOAT \
-	(s390_arch_flags & PF_IEEE_FLOAT)
+	(GCC_OPTION (s390_arch_flags) & PF_IEEE_FLOAT)
 #define TARGET_CPU_ZARCH \
-	(s390_arch_flags & PF_ZARCH)
+	(GCC_OPTION (s390_arch_flags) & PF_ZARCH)
 #define TARGET_CPU_LONG_DISPLACEMENT \
-	(s390_arch_flags & PF_LONG_DISPLACEMENT)
+	(GCC_OPTION (s390_arch_flags) & PF_LONG_DISPLACEMENT)
 #define TARGET_CPU_EXTIMM \
- 	(s390_arch_flags & PF_EXTIMM)
+ 	(GCC_OPTION (s390_arch_flags) & PF_EXTIMM)
 #define TARGET_CPU_DFP \
- 	(s390_arch_flags & PF_DFP)
+ 	(GCC_OPTION (s390_arch_flags) & PF_DFP)
 #define TARGET_CPU_Z10 \
- 	(s390_arch_flags & PF_Z10)
+ 	(GCC_OPTION (s390_arch_flags) & PF_Z10)
 #define TARGET_CPU_Z196 \
- 	(s390_arch_flags & PF_Z196)
+ 	(GCC_OPTION (s390_arch_flags) & PF_Z196)
 #define TARGET_CPU_ZEC12 \
- 	(s390_arch_flags & PF_ZEC12)
+ 	(GCC_OPTION (s390_arch_flags) & PF_ZEC12)
 #define TARGET_CPU_HTM \
- 	(s390_arch_flags & PF_TX)
+ 	(GCC_OPTION (s390_arch_flags) & PF_TX)
 
 /* These flags indicate that the generated code should run on a cpu
    providing the respective hardware facility when run in
@@ -84,7 +84,7 @@ enum processor_flags
 #define TARGET_HTM (TARGET_OPT_HTM)
 
 
-#define TARGET_AVOID_CMP_AND_BRANCH (s390_tune == PROCESSOR_2817_Z196)
+#define TARGET_AVOID_CMP_AND_BRANCH (GCC_OPTION (s390_tune) == PROCESSOR_2817_Z196)
 
 /* Run-time target specification.  */
 
@@ -595,7 +595,7 @@ extern const enum reg_class regclass_map[FIRST_PSEUDO_REGISTER];
 
 /* Select a format to encode pointers in exception handling data.  */
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE, GLOBAL)			    \
-  (flag_pic								    \
+  (GCC_OPTION (flag_pic)								    \
     ? ((GLOBAL) ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel | DW_EH_PE_sdata4 \
    : DW_EH_PE_absptr)
 
@@ -737,7 +737,7 @@ do {									\
 
 /* A C expression for the cost of a branch instruction.  A value of 1
    is the default; other values are interpreted relative to that.  */
-#define BRANCH_COST(speed_p, predictable_p) s390_branch_cost
+#define BRANCH_COST(speed_p, predictable_p) GCC_OPTION (s390_branch_cost)
 
 /* Nonzero if access to memory by bytes is slow and undesirable.  */
 #define SLOW_BYTE_ACCESS 1
@@ -810,7 +810,7 @@ do {									\
 
 /* Position independent code.  */
 
-#define PIC_OFFSET_TABLE_REGNUM (flag_pic ? 12 : INVALID_REGNUM)
+#define PIC_OFFSET_TABLE_REGNUM (GCC_OPTION (flag_pic) ? 12 : INVALID_REGNUM)
 
 #define LEGITIMATE_PIC_OPERAND_P(X)  legitimate_pic_operand_p (X)
 
diff --git a/gcc/config/score/score.c b/gcc/config/score/score.c
index e238d6d..9c52ff6 100644
--- a/gcc/config/score/score.c
+++ b/gcc/config/score/score.c
@@ -311,7 +311,7 @@ score_compute_frame_size (HOST_WIDE_INT size)
   f->mask = 0;
   f->var_size = SCORE_STACK_ALIGN (size);
   f->args_size = crtl->outgoing_args_size;
-  f->cprestore_size = flag_pic ? UNITS_PER_WORD : 0;
+  f->cprestore_size = GCC_OPTION (flag_pic) ? UNITS_PER_WORD : 0;
   if (f->var_size == 0 && crtl->is_leaf)
     f->args_size = f->cprestore_size = 0;
 
@@ -574,7 +574,7 @@ score_function_prologue (FILE *file, HOST_WIDE_INT size ATTRIBUTE_UNUSED)
   HOST_WIDE_INT tsize = f->total_size;
 
   fnname = XSTR (XEXP (DECL_RTL (current_function_decl), 0), 0);
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       fputs ("\t.ent\t", file);
       assemble_name (file, fnname);
@@ -583,7 +583,7 @@ score_function_prologue (FILE *file, HOST_WIDE_INT size ATTRIBUTE_UNUSED)
   assemble_name (file, fnname);
   fputs (":\n", file);
 
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       fprintf (file,
                "\t.frame\t%s," HOST_WIDE_INT_PRINT_DEC ",%s, %d\t\t"
@@ -611,7 +611,7 @@ score_function_prologue (FILE *file, HOST_WIDE_INT size ATTRIBUTE_UNUSED)
 static void
 score_function_epilogue (FILE *file, HOST_WIDE_INT size ATTRIBUTE_UNUSED)
 {
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       const char *fnname;
       fnname = XSTR (XEXP (DECL_RTL (current_function_decl), 0), 0);
@@ -648,7 +648,7 @@ score_select_rtx_section (enum machine_mode mode, rtx x, unsigned HOST_WIDE_INT
 {
   if (GET_MODE_SIZE (mode) <= SCORE_SDATA_MAX)
     return get_named_section (0, ".sdata", 0);
-  else if (flag_pic && score_symbolic_expression_p (x))
+  else if (GCC_OPTION (flag_pic) && score_symbolic_expression_p (x))
     return get_named_section (0, ".data.rel.ro", 3);
   else
     return mergeable_constant_section (mode, align, 0);
@@ -686,7 +686,7 @@ score_asm_file_start (void)
   fprintf (asm_out_file, ASM_COMMENT_START
            "GCC for S+core %s \n", SCORE_GCC_VERSION);
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     fprintf (asm_out_file, "\t.set pic\n");
 }
 
@@ -719,7 +719,7 @@ score_asm_file_end (void)
 static void
 score_option_override (void)
 {
-  flag_pic = false;
+  GCC_OPTION (flag_pic) = false;
   score_sdata_max = SCORE_DEFAULT_SDATA_MAX;
 
 }
@@ -1142,14 +1142,14 @@ score_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
       return false;
 
     case MULT:
-      *total = optimize_size ? COSTS_N_INSNS (2) : COSTS_N_INSNS (12);
+      *total = GCC_OPTION (optimize_size) ? COSTS_N_INSNS (2) : COSTS_N_INSNS (12);
       return true;
 
     case DIV:
     case MOD:
     case UDIV:
     case UMOD:
-      *total = optimize_size ? COSTS_N_INSNS (2) : COSTS_N_INSNS (33);
+      *total = GCC_OPTION (optimize_size) ? COSTS_N_INSNS (2) : COSTS_N_INSNS (33);
       return true;
 
     case SIGN_EXTEND:
@@ -1458,7 +1458,7 @@ score_prologue (void)
 
   size = f->total_size - f->gp_reg_size;
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     emit_insn (gen_cpload_score7 ());
 
   for (regno = (int) GP_REG_LAST; regno >= (int) GP_REG_FIRST; regno--)
@@ -1504,7 +1504,7 @@ score_prologue (void)
   if (frame_pointer_needed)
     EMIT_PL (emit_move_insn (hard_frame_pointer_rtx, stack_pointer_rtx));
 
-  if (flag_pic && f->cprestore_size)
+  if (GCC_OPTION (flag_pic) && f->cprestore_size)
     {
       if (frame_pointer_needed)
         emit_insn (gen_cprestore_use_fp_score7 (GEN_INT (size - f->cprestore_size)));
@@ -1931,7 +1931,7 @@ score_init_cumulative_args (CUMULATIVE_ARGS *cum,
 static void
 score_conditional_register_usage (void)
 {
-   if (!flag_pic)
+   if (!GCC_OPTION (flag_pic))
      fixed_regs[PIC_OFFSET_TABLE_REGNUM] =
      call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 0;
 }
diff --git a/gcc/config/score/score.h b/gcc/config/score/score.h
index 125a209..6101ce4 100644
--- a/gcc/config/score/score.h
+++ b/gcc/config/score/score.h
@@ -759,7 +759,7 @@ typedef struct score_args
   do {										\
     if (TARGET_SCORE7)								\
       {										\
-	if (flag_pic)								\
+	if (GCC_OPTION (flag_pic))								\
 	  fprintf (STREAM, "\t.gpword %sL%d\n", LOCAL_LABEL_PREFIX, VALUE);	\
 	else									\
 	  fprintf (STREAM, "\t.word %sL%d\n", LOCAL_LABEL_PREFIX, VALUE);	\
